package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;


/**
 * 实体[WFActor] 数据对象
 */
@TableName(value = "T_SRFWFACTOR",resultMap = "WFActorResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class WFActor extends EntityBase implements Serializable{

    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String params;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    @TableId(value= "wfactorid",type=IdType.UUID)//指定主键生成策略
    private String wfactorid;
    private String wfactorname;
    private String wfactorparam;
    private String wfactorparam2;
    @Dict(dictName = "ionicdemo_WFActorTypeCodeList")
    private String wfactortype;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[处理变量]
     *  @param params
     */
    public void setParams(String params){
        if(StringUtils.isEmpty(params))
            params=null;
        this.params = params;
        this.set("paramsdirtyflag",true);
    }
    /**
     *  获取属性值[处理变量]
     */
    public String getParams(){
        return this.params;
    }
    /**
     *  重置属性值[处理变量]
     */
    public void resetParams(){
        this.set("paramsdirtyflag",false);
        this.params = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[工作流操作者标识]
     *  @param wfactorid
     */
    public void setWfactorid(String wfactorid){
        if(StringUtils.isEmpty(wfactorid))
            wfactorid=null;
        this.wfactorid = wfactorid;
        this.set("wfactoriddirtyflag",true);
    }
    /**
     *  获取属性值[工作流操作者标识]
     */
    public String getWfactorid(){
        return this.wfactorid;
    }
    /**
     *  重置属性值[工作流操作者标识]
     */
    public void resetWfactorid(){
        this.set("wfactoriddirtyflag",false);
        this.wfactorid = null;
    }
    /**
     *  设置属性值[工作流操作者名称]
     *  @param wfactorname
     */
    public void setWfactorname(String wfactorname){
        if(StringUtils.isEmpty(wfactorname))
            wfactorname=null;
        this.wfactorname = wfactorname;
        this.set("wfactornamedirtyflag",true);
    }
    /**
     *  获取属性值[工作流操作者名称]
     */
    public String getWfactorname(){
        return this.wfactorname;
    }
    /**
     *  重置属性值[工作流操作者名称]
     */
    public void resetWfactorname(){
        this.set("wfactornamedirtyflag",false);
        this.wfactorname = null;
    }
    /**
     *  设置属性值[操作者参数]
     *  @param wfactorparam
     */
    public void setWfactorparam(String wfactorparam){
        if(StringUtils.isEmpty(wfactorparam))
            wfactorparam=null;
        this.wfactorparam = wfactorparam;
        this.set("wfactorparamdirtyflag",true);
    }
    /**
     *  获取属性值[操作者参数]
     */
    public String getWfactorparam(){
        return this.wfactorparam;
    }
    /**
     *  重置属性值[操作者参数]
     */
    public void resetWfactorparam(){
        this.set("wfactorparamdirtyflag",false);
        this.wfactorparam = null;
    }
    /**
     *  设置属性值[操作者参数2]
     *  @param wfactorparam2
     */
    public void setWfactorparam2(String wfactorparam2){
        if(StringUtils.isEmpty(wfactorparam2))
            wfactorparam2=null;
        this.wfactorparam2 = wfactorparam2;
        this.set("wfactorparam2dirtyflag",true);
    }
    /**
     *  获取属性值[操作者参数2]
     */
    public String getWfactorparam2(){
        return this.wfactorparam2;
    }
    /**
     *  重置属性值[操作者参数2]
     */
    public void resetWfactorparam2(){
        this.set("wfactorparam2dirtyflag",false);
        this.wfactorparam2 = null;
    }
    /**
     *  设置属性值[角色类型]
     *  @param wfactortype
     */
    public void setWfactortype(String wfactortype){
        if(StringUtils.isEmpty(wfactortype))
            wfactortype=null;
        this.wfactortype = wfactortype;
        this.set("wfactortypedirtyflag",true);
    }
    /**
     *  获取属性值[角色类型]
     */
    public String getWfactortype(){
        return this.wfactortype;
    }
    /**
     *  重置属性值[角色类型]
     */
    public void resetWfactortype(){
        this.set("wfactortypedirtyflag",false);
        this.wfactortype = null;
    }
    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetParams();
        resetUpdatedate();
        resetUpdateman();
        resetWfactorid();
        resetWfactorname();
        resetWfactorparam();
        resetWfactorparam2();
        resetWfactortype();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public WFActor copyTo(WFActor targetEntity)
	{
		BeanCopier copier=BeanCopier.create(WFActor.class, WFActor.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetWfactorid();
		return targetEntity;
	}
}